import * as React from 'react';
import { Store, FormInstance, FieldData, ValidateMessages, Callbacks } from './interface';
declare type BaseFormProps = Omit<React.FormHTMLAttributes<HTMLFormElement>, 'onSubmit'>;
export interface StateFormProps extends BaseFormProps {
    initialValues?: Store;
    form?: FormInstance;
    children?: (() => JSX.Element | React.ReactNode) | React.ReactNode;
    fields?: FieldData[];
    name?: string;
    validateMessages?: ValidateMessages;
    onValuesChange?: Callbacks['onValuesChange'];
    onFieldsChange?: Callbacks['onFieldsChange'];
    onFinish?: (values: Store) => void;
}
declare const StateForm: React.FunctionComponent<StateFormProps>;
export default StateForm;
