"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _FieldContext = _interopRequireWildcard(require("./FieldContext"));

var _Field = _interopRequireDefault(require("./Field"));

var _valueUtil = require("./utils/valueUtil");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var List = function List(_ref) {
  var name = _ref.name,
      children = _ref.children;

  // User should not pass `children` as other type.
  if (typeof children !== 'function') {
    return null;
  }

  return React.createElement(_FieldContext.default.Consumer, null, function (context) {
    var parentPrefixName = (0, _valueUtil.getNamePath)(context.prefixName) || [];
    var prefixName = [].concat(_toConsumableArray(parentPrefixName), _toConsumableArray((0, _valueUtil.getNamePath)(name)));

    var shouldUpdate = function shouldUpdate(prevValue, nextValue, _ref2) {
      var source = _ref2.source;

      if (source === 'internal') {
        return false;
      }

      return prevValue !== nextValue;
    };

    return React.createElement(_FieldContext.default.Provider, {
      value: _objectSpread({}, context, {
        prefixName: prefixName
      })
    }, React.createElement(_Field.default, {
      name: [],
      shouldUpdate: shouldUpdate
    }, function (_ref3) {
      var _ref3$value = _ref3.value,
          value = _ref3$value === void 0 ? [] : _ref3$value,
          onChange = _ref3.onChange;
      var getInternalHooks = context.getInternalHooks,
          getFieldValue = context.getFieldValue,
          setFieldsValue = context.setFieldsValue,
          setFields = context.setFields;
      /**
       * Always get latest value in case user update fields by `form` api.
       */

      var operations = {
        add: function add() {
          var newValue = getFieldValue(prefixName) || [];
          onChange([].concat(_toConsumableArray(newValue), [undefined]));
        },
        remove: function remove(index) {
          var _getInternalHooks = getInternalHooks(_FieldContext.HOOK_MARK),
              getFields = _getInternalHooks.getFields;

          var newValue = getFieldValue(prefixName) || [];
          var namePathList = newValue.map(function (__, i) {
            return [].concat(_toConsumableArray(prefixName), [i]);
          });
          var fields = getFields(namePathList).filter(function (__, i) {
            return i !== index;
          }).map(function (fieldData, i) {
            return _objectSpread({}, fieldData, {
              name: [].concat(_toConsumableArray(prefixName), [i])
            });
          });

          var nextValue = _toConsumableArray(newValue);

          nextValue.splice(index, 1);
          setFieldsValue((0, _valueUtil.setValue)({}, prefixName, []));
          setFields(fields);
        }
      };
      return children(value.map(function (__, index) {
        return {
          name: index
        };
      }), operations);
    }));
  });
};

var _default = List;
exports.default = _default;