import * as React from 'react';
import { FormInstance } from './interface';
import Field from './Field';
import List from './List';
import useForm from './useForm';
import { StateFormProps } from './Form';
import { FormProvider } from './FormContext';
declare const InternalStateForm: React.ForwardRefExoticComponent<StateFormProps & React.RefAttributes<FormInstance>>;
declare type InternalStateForm = typeof InternalStateForm;
interface RefStateForm extends InternalStateForm {
    FormProvider: typeof FormProvider;
    Field: typeof Field;
    List: typeof List;
    useForm: typeof useForm;
}
declare const RefStateForm: RefStateForm;
export { FormInstance, Field, useForm, FormProvider };
export default RefStateForm;
