import { InternalNamePath, FormInstance, InternalFormInstance } from './interface';
interface UpdateAction {
    type: 'updateValue';
    namePath: InternalNamePath;
    value: any;
}
export declare type ReducerAction = UpdateAction;
export declare class FormStore {
    private forceRootUpdate;
    private subscribable;
    private store;
    private fieldEntities;
    private errorCache;
    private initialValues;
    private callbacks;
    private validateMessages;
    private lastValidatePromise;
    constructor(forceRootUpdate: () => void);
    getForm: () => InternalFormInstance;
    private getInternalHooks;
    private useSubscribe;
    private setInitialValues;
    private getInitialValue;
    private setCallbacks;
    private setValidateMessages;
    /**
     * Get registered field entities.
     * @param pure Only return field which has a `name`. Default: false
     */
    private getFieldEntities;
    private getFieldsValue;
    private getFieldValue;
    private getFieldsError;
    private getFieldError;
    private isFieldsTouched;
    private isFieldTouched;
    private isFieldsValidating;
    private isFieldValidating;
    private resetFields;
    private setFields;
    private getFields;
    private registerField;
    private dispatch;
    private notifyObservers;
    private updateValue;
    private setFieldsValue;
    private getDependencyChildrenFields;
    private triggerOnFieldsChange;
    private validateFields;
}
declare function useForm(form?: FormInstance): [FormInstance];
export default useForm;
